#!/bin/bash
#
# Subject: シンプルなxmlから要素の取り出し方

readom() { local IFS=\> ; read -d \< TAG ELEMENT ; }

usage_exit() {
    printf "%s [-cieh] [tag ...]\n" $0
    echo "   -c : color"
    echo "   -i : indent"
    echo "   -e : eliminate comment"
    echo "   -h : Help"
    exit
}

HB=""
HCB=""
HE=""

ts=0
tabs=0

ec=0
CB=$'^!--'
CE=$'--$'

while getopts :cieh OPT ; do
  case $OPT in
    c)
        HB=$'\033[0;35m'
        HCB=$'\033[0;36m'
        HE=$'\033[0;0m'
        ;;
    i) #ts=$(expr ${OPTARG} + 0 2> /dev/null) || ts=0
        ts=2
        ;;
    e) ec=1 ;;
    h) usage_exit ;;
  esac
done
shift $((OPTIND - 1))

end='^/'       # end tag
mtt='(/|\?)$' # empty-element tag & ?xml...?
while readom; do
    if [[ "${TAG}" =~ $end ]]; then
        let tabs-=$ts
    elif [ -n "${TAG}" ]; then
        # escaping: ELEMENT内は、空行を削除
        e=$( sed -e '/^[ \t]*$/d' \
                 -e 's/&lt;/</g' -e 's/&gt;/>/g' -e 's/&amp;/\&/g' \
                 -e "s/&apos;/'/g" -e 's/&quot;/"/g' <<< "${ELEMENT}" )
        if [[ ${TAG} =~ $CB && ${TAG} =~ $CE ]]; then
            if [ $ec -gt 0 ]; then
                t=''
            else
                t=$( sed -e 's/^!--//; s/--$//' <<< "${TAG}" )
            fi
            printf "%s%*s%s%s %s\n" "$HCB" $tabs "" "${t}" "$HE" "${e}"
        else
            # escaping: TAGは、empty-element tagの処理を加える
            t=$( sed -e 's:/$::' \
                     -e 's/&lt;/</g' -e 's/&gt;/>/g' -e 's/&amp;/\&/g' \
                     -e "s/&apos;/'/g" -e 's/&quot;/"/g' <<< "${TAG}" )
            if [ $# -gt 0 ]; then
                for tg in "$@" ; do
                    [ "$tg" = "${t}" ] &&
                        printf "%s%*s%s:%s %s\n" "$HB" $tabs "" "${t}" "$HE" "${e}"
                done
            else
                printf "%s%*s%s:%s %s\n" "$HB" $tabs "" "${t}" "$HE" "${e}"
            fi
            [[ "${TAG}" =~ $mtt ]] || let tabs+=$ts
        fi
    fi
done

